AddBan_Window.add(new GuiPopUpMenuCtrl(BanReasonList)
	{
		position = "38 145";
		extent = "308 19";
		
		text = "Ban Reason:";
		command = "BanForReason(BanReasonList.getValue());";
		
		profile = "GuiPopUpMenuProfile";
	});

AddBan_Window.add(new GuiSwatchCtrl(BanReasonBlocker)
	{
		position = "38 145";
		extent = "308 19";
		
		color = "200 200 200 200";
		visible = 0;
	});

AddBan_Window.extent = getWord(%ext = AddBan_Window.extent, 0) SPC getWord(%ext, 1) + 30;

function BanForReason(%reason)
{
	BanReasonList.setValue("Ban Reason:");
	if(%reason $= "Ban Reason:")
		return;
	AddBan_Reason.setValue(%reason);
	%pos = $Pref::Client::BanReason[strReplace(filterString(%reason, "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm "), " ", "_")];
	%time = $Pref::Client::BanTime[%pos];
	if(%time < 0 || %time > 23039)
	{
		AddBan_Forever.setValue(1);
		AddBanGui.clickForever();
		return;
	}
	while(%time >= 1440)
	{ %days++; %time -= 1440; }
	while(%time >= 60)
	{ %hours++; %time -= 60; }
	%mins = %time;
	AddBan_Days.setText(AddBan_Days.getTextByID(%days));
	AddBan_Hours.setText(AddBan_Hours.getTextByID(%hours));
	AddBan_Minutes.setText(AddBan_Minutes.getTextByID(%mins));
}

function addBanReason(%reason, %time)
{
	$Pref::Client::BanReason[%pos=(-1+$Pref::Client::BanReasons++)] = %reason;
	$Pref::Client::BanReason[strReplace(filterString(%reason, "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm "), " ", "_")] = %pos;
	$Pref::Client::BanTime[%pos] = %time;
	BanReasonList.add(%reason, %pos);
}

function addBanReasons()
{
	//    Even though this is incredibly inefficient, I'm too lazy to rewrite the rest of the mod
	//to properly support customizable ban reasons. This worked back when I still had set reasons.
	for(%i=0;%i<$Pref::Client::BanReasons;%i++)
		%reason[-1+%reasons++] = $Pref::Client::BanReason[%i] TAB $Pref::Client::BanTime[%i];
	$Pref::Client::BanReasons = 0;
	for(%i=0;%i<%reasons;%i++)
		addBanReason(getField(%reason[%i], 0), getField(%reason[%i], 1));
}
addBanReasons();

//Ripped from Client_AvatarSaver.zip/gui.cs and renamed - it's a list with buttons, why reinvent the wheel?
new GuiControl(BanReasonGUI)
{
	new GuiWindowCtrl(BanReasonWindow)
	{
		position = "240 120";
		extent = "240 360";
		
		closeCommand = "toggleBanReasonsGUI(1);";
		command = "toggleBanReasonsGUI(1);";
		accelerator = "Escape";
		
		text = "Ban Reason Editor";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiSwatchCtrl()
		{
			position = "20 40";
			extent = "200 270";
			
			color = "255 255 255 128";
		};
		
		new GuiScrollCtrl()
		{
			position = "20 40";
			extent = "200 270";
			
			profile = "ColorScrollProfile";
			
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			willFirstRespond = 1;
			
			new GuiTextListCtrl(BanReasonsList)
			{
				position = "0 0";
				fitParentWidth = 1;
				columns = "0";
				
				clipColumnText = 0;
				profile = "GuiTextListProfile";
			};
		};
		
		new GuiBitmapButtonCtrl(BanReason_AddButton)
		{
			position = "57 316";
			extent = "60 24";
			
			text = "Add";
			mColor = "102 102 255 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "BanReason_AddReason();";
		};
		
		new GuiBitmapButtonCtrl(BanReason_DeleteButton)
		{
			position = "123 316";
			extent = "60 24";
			
			text = "Remove";
			mColor = "255 102 102 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "BanReason_DeleteReason();";
		};
	};
};

package BanReason
{
	function AddBanGUI::ban(%this)
	{
		if(%this.addingReason)
		{
			%time = (getWord(AddBan_Days.getValue(), 0) * 1440) + (getWord(AddBan_Hours.getValue(), 0) * 60) + getWord(AddBan_Minutes.getValue(), 0);
			if(AddBan_Forever.getValue())
				%time = -1;
			addBanReason(AddBan_Reason.getValue(), %time);
			refreshBanReasonsList();
			%this.addingReason = 0;
			BanReasonBlocker.setVisible(0);
			AddBan_Window.getObject(8).setText("BAN >>");
			Canvas.popDialog(%this);
			
			//Restore the banning GUI to its previous state
			AddBan_Forever.setValue(AddBanGUI.foreverValue);
			AddBan_Days.setValue(AddBanGUI.daysValue);
			AddBan_Hours.setValue(AddBanGUI.hoursValue);
			AddBan_Minutes.setValue(AddBanGUI.minutesValue);
			AddBanGUI.clickForever();
		}
		else
			Parent::ban(%this);
	}
	
	function AddBanGUI::onSleep(%this)
	{
		if(%this.addingReason)
		{
			%this.addingReason = 0;
			BanReasonBlocker.setVisible(0);
			AddBan_Window.getObject(8).setText("BAN >>");
			
			//Restore the banning GUI to its previous state
			AddBan_Forever.setValue(AddBanGUI.foreverValue);
			AddBan_Days.setValue(AddBanGUI.daysValue);
			AddBan_Hours.setValue(AddBanGUI.hoursValue);
			AddBan_Minutes.setValue(AddBanGUI.minutesValue);
			AddBan_Reason.setValue(AddBanGUI.reasonValue);
			AddBanGUI.clickForever();
		}
		Parent::onSleep(%this);
	}
};
activatePackage("BanReason");

function refreshBanReasonsList()
{
	%list = BanReasonsList.getID();
	%list.clear();
	for(%i=0;%i<$Pref::Client::BanReasons;%i++)
		%list.addRow(%i, $Pref::Client::BanReason[%i]);
}

function BanReason_AddReason()
{
	Canvas.pushDialog(AddBanGUI);
	BanReasonBlocker.setVisible(1);
	AddBan_Window.getObject(8).setText("Add");
	AddBanGUI.addingReason = 1;
	
	//Restorative values
	AddBanGUI.foreverValue = AddBan_Forever.getValue();
	AddBanGUI.daysValue = AddBan_Days.getValue();
	AddBanGUI.hoursValue = AddBan_Hours.getValue();
	AddBanGUI.minutesValue = AddBan_Minutes.getValue();
	AddBanGui.reasonValue = AddBan_Reason.getValue();
}

function BanReason_DeleteReason()
{
	%list = BanReasonsList.getID();
	if((%id = %list.getSelectedID()) != -1)
	{
		%reason = %list.getRowTextByID(%id);
		BanReasonList.clear();
		for(%i=0;%i<$Pref::Client::BanReasons;%i++)
		{
			if($Pref::Client::BanReason[%i] $= %reason)
				%shift++;
			else
			{
				$Pref::Client::BanReason[%i-%shift] = $Pref::Client::BanReason[%i];
				$Pref::Client::BanTime[%i-%shift] = $Pref::Client::BanTime[%i];
				BanReasonList.add($Pref::Client::BanReason[%i], %i);
			}
		}
		$Pref::Client::BanReasons -= %shift;
	}
	refreshBanReasonsList();
}

function toggleBanReasonsGUI(%tog)
{
	if(!%tog)
		return;
	%this = BanReasonGUI.getID();
	if(%this.isAwake())
		Canvas.popDialog(%this);
	else
		Canvas.pushDialog(%this);
}

if(!$BanReasonGUI::boundCommand)
{
	$BanReasonGUI::boundCommand = 1;
	$remapDivision[$remapCount] = "Ban Reason";
	$remapName[$remapCount] = "Toggle Editor GUI";
	$remapCmd[$remapCount] = "toggleBanReasonsGUI";
	$remapCount++;
}

//from System_ReturnToBlockland.zip/support/functions.cs
//- filterString (removes all characters not in %allowed)
function filterString(%string,%allowed)
{
   for(%i=0;%i<strLen(%string);%i++)
   {
      %char = getSubStr(%string,%i,1);
      if(strPos(%allowed,%char) >= 0)
         %return = %return@%char;
   }
   return %return;
}